# Festo FHPP XML-RPC Server for UR10/uraxis
See also uraxis

#### /
Index

#### /rel(int relPos, int speed) 
Perform relative movement by relPos ticks at speed.
Blocks until position reached (calls checkPos()).

#### /abs(int targetPos, int speed)
Perform absolute movement to targetPos at speed.
Blocks until position reached (calls checkPos()).

### /getpos()
Fetches live status from axis and returns current position.

### /ready
Enable freedrive/teach - Mode
    
### /status
Returns map of status flags
    
### Usage
```python
Usage: <main class> [-h] [-aip=<axisIP>] [-ap=<axisPort>] [-p=<port>]
      -aip, --axisip=<axisIP>
                      Axis ip address
      -ap, --axisport=<axisPort>
                      Axis modbus port
  -h, --help          display a help message
  -p, --port=<port>   HTTP Server port
```

```
./jdk-12+33-jre/bin/java -jar urweb-1.0-SNAPSHOT-shaded.jar
```

## Deployment

[systemd service documentation](https://www.freedesktop.org/software/systemd/man/systemd.service.html)
```python
[Unit]
Description=uraxisdaemon
After=syslog.target

[Service]
Type=notify
NotifyAccess=all
WorkingDirectory=/opt/myserver/
ExecStart=/usr/bin/java -server -jar uraxisdaemon.jar -p=8080 -aip=192.168.30.200 -ap=30001
# WatchdogSec=30
Restart=always

[Install]
WantedBy=multi-user.target
```